SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

Exception subclass: #ErrorMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'KevinKujawski 5/22/2013 20:20'!
canNotConvertMeasurementException
	
	^ ErrorMeasure .! !

!MeasureTest methodsFor: 'temperature units' stamp: 'KevinKujawski 5/22/2013 19:59'!
celsius
	
	^TemperatureUnit new initializeWithaName: 'celsius' andFactor: 1.! !

!MeasureTest methodsFor: 'distance units' stamp: 'KevinKujawski 5/22/2013 19:58'!
centimeter
	
	^DistanceUnit new initializeWithaName: 'centimeter' andFactor: 100 .! !

!MeasureTest methodsFor: 'time units' stamp: 'KevinKujawski 5/22/2013 19:59'!
day
	
	^TimeUnit new initializeWithaName: 'day' andFactor: 1/(24*3600) .! !

!MeasureTest methodsFor: 'distance units' stamp: 'KevinKujawski 5/22/2013 19:58'!
decameter
	
	^DistanceUnit new initializeWithaName: 'decameter' andFactor: 1/10.! !

!MeasureTest methodsFor: 'distance units' stamp: 'KevinKujawski 5/22/2013 19:58'!
decimeter
	
	^DistanceUnit new initializeWithaName: 'decimeter' andFactor: 10.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'KevinKujawski 5/22/2013 21:47'!
eightCubicMeters

	^self twoMeters * self twoMeters * self twoMeters! !

!MeasureTest methodsFor: 'temperature units' stamp: 'KevinKujawski 5/22/2013 19:59'!
fahrenheit
	
	^TemperatureUnit new initializeWithaName: 'fahrenheit' andFactor:1/64.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'KevinKujawski 5/23/2013 13:30'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	"^self error: 'Implementar la formula de velocidad final: vf = vi + a * t'"
	^ initialSpeed + (anAcceleration * aTimePeriod)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'KevinKujawski 5/22/2013 21:47'!
fourSquaredMeters

	^self twoMeters * self twoMeters.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'KevinKujawski 5/24/2013 13:31'!
halfMeterBySecond

	^self oneMeter / self twoSeconds .! !

!MeasureTest methodsFor: 'distance units' stamp: 'KevinKujawski 5/22/2013 19:57'!
hectometer
	
	^DistanceUnit new initializeWithaName: 'hectometer' andFactor: 1/100.! !

!MeasureTest methodsFor: 'time units' stamp: 'KevinKujawski 5/22/2013 19:59'!
hour
	
	^TimeUnit new initializeWithaName: 'hour' andFactor: 1/3600 .! !

!MeasureTest methodsFor: 'temperature units' stamp: 'KevinKujawski 5/22/2013 19:59'!
kelvin
	
		^TemperatureUnit new initializeWithaName: 'kelvin' andFactor:1/64.! !

!MeasureTest methodsFor: 'distance units' stamp: 'KevinKujawski 5/22/2013 19:57'!
kilometer
	
	^DistanceUnit new initializeWithaName: 'kilometer' andFactor: 1/1000.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'KevinKujawski 5/22/2013 19:57'!
meter

	^DistanceUnit new initializeWithaName: 'meter' andFactor: 1.! !

!MeasureTest methodsFor: 'distance units' stamp: 'KevinKujawski 5/22/2013 19:57'!
millimeter
	
	^DistanceUnit new initializeWithaName: 'milimeter' andFactor: 1000.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'KevinKujawski 5/22/2013 20:49'!
minusOneMeter 
	
	^  DistanceMeasure  newWithAmount: (-1) andUnit: self meter.! !

!MeasureTest methodsFor: 'time units' stamp: 'KevinKujawski 5/22/2013 19:59'!
minute
	
	^TimeUnit new initializeWithaName: 'minute' andFactor: 1/60.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GuadalupeFlores 5/20/2013 21:16'!
oneCelsius
	^  TemperatureMeasure  newWithAmount: 1 andUnit: self celsius.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GuadalupeFlores 5/20/2013 20:24'!
oneCentimeter
	
	^ Measure  newWithAmount: 1 andUnit: self centimeter.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuadalupeFlores 5/20/2013 21:27'!
oneDay
	
	^ TimeMeasure  newWithAmount: 1 andUnit: self day.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuadalupeFlores 5/20/2013 21:27'!
oneHour
	
	^ TimeMeasure  newWithAmount: 1 andUnit: self hour.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GuadalupeFlores 5/20/2013 21:17'!
oneHundredCentimeters
	
	^ DistanceMeasure  newWithAmount: 100 andUnit: self centimeter.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'KevinKujawski 5/24/2013 23:33'!
oneHundredTwentyOneMetersPerSecond

	^(DistanceMeasure  newWithAmount: 121 andUnit: self meter) / self oneSecond ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GuadalupeFlores 5/20/2013 21:17'!
oneMeter
	
	^  DistanceMeasure  newWithAmount: 1 andUnit: self meter.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'KevinKujawski 5/23/2013 13:30'!
oneMeterPerSecond

	^self oneMeter / self oneSecond ! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuadalupeFlores 5/20/2013 21:04'!
oneMinute
	
	^ TimeMeasure  newWithAmount: 1 andUnit: self minute.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuadalupeFlores 5/20/2013 21:04'!
oneSecond

	^ TimeMeasure  newWithAmount: 1 andUnit: self second.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'KevinKujawski 5/22/2013 21:38'!
oneSquaredMeter

	^(self oneMeter * self oneMeter)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'KevinKujawski 5/22/2013 21:48'!
oneSquaredSecond

	^(self oneSecond * self oneSecond)! !

!MeasureTest methodsFor: 'time units' stamp: 'KevinKujawski 5/22/2013 19:59'!
second
	
	^TimeUnit new initializeWithaName: 'second' andFactor: 1.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuadalupeFlores 5/20/2013 21:28'!
sixtyMinutes
	
	^ TimeMeasure  newWithAmount: 60 andUnit: self minute.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuadalupeFlores 5/20/2013 21:28'!
sixtyOneSeconds
	
	^ TimeMeasure  newWithAmount: 61 andUnit: self second.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuadalupeFlores 5/20/2013 21:17'!
sixtySeconds
	
	^ TimeMeasure  newWithAmount: 60 andUnit: self second.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:11'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'milimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GuadalupeFlores 5/20/2013 21:24'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'KevinKujawski 5/24/2013 13:31'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self oneMeter / self twoSeconds) = self halfMeterBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'KevinKujawski 5/25/2013 02:38'!
test21MeasuresProvideATotalOrder
	
	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GuadalupeFlores 5/20/2013 21:16'!
thirtyTwoFahrenheits
	
	^  TemperatureMeasure  newWithAmount: 32 andUnit: self fahrenheit .! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuadalupeFlores 5/20/2013 21:28'!
twentyFourHours
	
	^ TimeMeasure  newWithAmount: 24 andUnit: self hour.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'KevinKujawski 5/22/2013 20:37'!
twoCelsius
	
	^  TemperatureMeasure  newWithAmount: 2 andUnit: self celsius.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GuadalupeFlores 5/20/2013 21:17'!
twoHundredCentimeters
	
	^  DistanceMeasure  newWithAmount: 200 andUnit: self centimeter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GuadalupeFlores 5/20/2013 21:17'!
twoMeters
	
	^  DistanceMeasure  newWithAmount: 2 andUnit: self meter.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'KevinKujawski 5/22/2013 23:32'!
twoMetersBySecond

	^self twoMeters * self oneSecond .! !

!MeasureTest methodsFor: 'compound measures' stamp: 'KevinKujawski 5/22/2013 23:33'!
twoMetersPerSquaredSecond

	^ self twoMeters / (self oneSquaredSecond )! !

!MeasureTest methodsFor: 'compound measures' stamp: 'KevinKujawski 5/22/2013 21:48'!
twoMetersTimesSecond

	^self oneMeter * self twoSeconds! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuadalupeFlores 5/20/2013 21:28'!
twoSeconds
	
	^ TimeMeasure  newWithAmount: 2 andUnit: self second.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GuadalupeFlores 5/20/2013 21:16'!
zeroCelsius
	^ TemperatureMeasure  newWithAmount: 0 andUnit: self celsius.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'KevinKujawski 5/22/2013 20:37'!
zeroKelvin
	^ TemperatureMeasure  newWithAmount: 0 andUnit: self kelvin.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'KevinKujawski 5/22/2013 20:48'!
zeroMeters

	^  DistanceMeasure  newWithAmount: 0 andUnit: self meter.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuadalupeFlores 5/20/2013 21:29'!
zeroSeconds
	
	^ TimeMeasure  newWithAmount: 0 andUnit: self second.! !

Object subclass: #Measure
	instanceVariableNames: 'amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Measure class
	instanceVariableNames: 'amount unit'!

Measure class
	instanceVariableNames: 'amount unit'!

!Measure class methodsFor: 'distance' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
newWithAmount: anAmount andUnit: aDistanceUnit 
	^self new newWithAmount: anAmount andUnit: aDistanceUnit! !

!Measure class methodsFor: 'distance' stamp: 'GuadalupeFlores 5/20/2013 20:11'!
oneMeter
	^Distance newWithAmount: 1 andUnit: (Unit newWithName: 'meter' andFactor: 1)! !

!Measure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 02:28'!
* anObject
	
	(anObject isKindOf: Measure ) ifTrue: [ ^ (ProductMeasure newWithAmount: (self amount * anObject amount) andUnit: (self unit * anObject unit) ) ].
	^  (self class) newWithAmount: (amount * anObject) andUnit: unit.
	
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 20:41'!
+  aMeasure 		
	 |newDistance|
	self compareSystemMeasure: aMeasure unit.
	newDistance := (self class) new.
	
	newDistance  newWithAmount: ((self convertToBase )amount + (aMeasure convertToBase) amount) andUnit:  (aMeasure convertToBase) unit.
	
	^ newDistance.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 20:42'!
- aMeasure 
	|newDistance|
	self compareSystemMeasure: aMeasure unit.
	newDistance := (self class)  new.
	newDistance  newWithAmount: ((self convertToBase) amount - (aMeasure convertToBase) amount) andUnit: (self convertToBase) unit.
	
	^ newDistance.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 02:28'!
/ anObject

	(anObject isKindOf: Measure) ifTrue: [ 
		(anObject unit = unit) ifTrue: [ ^(self amount / anObject amount) ].		
		^ (ProductMeasure newWithAmount: (self amount / anObject amount) andUnit: (self unit / anObject unit) ) ].
	^ (self class)  newWithAmount: (amount / anObject) andUnit: unit.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 02:28'!
< aMeasure 	
	^ amount < (aMeasure) amount.
	
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
<= aDistance 	
	^ amount <= (aDistance convertTo: unit) amount.
	
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/24/2013 23:58'!
= aMeasure

	"^((self class)  = (aMeasure class) ) and: [(aMeasure convertToBase) amount = (self convertToBase) amount]"
	^(aMeasure ) amount = (self ) amount.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
> aDistance 	
	^ amount > (aDistance convertTo: unit) amount.
	
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
>= aDistance 	
	^ amount >= (aDistance convertTo: unit) amount.
	
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
amount
	^amount.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
between:  anotherDistance and:  otherDistance 
	self amount > (anotherDistance convertTo: unit) amount
	ifTrue: [self amount < (otherDistance convertTo: unit) amount
			 ifTrue: [^true  ]
			 ifFalse: [^ false ]
			]
	ifFalse:[^ false ]
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
between:  anotherDistance to:  otherDistance 
	self amount > (anotherDistance convertTo: unit) amount
	ifTrue: [self amount < (otherDistance convertTo: unit) amount
			 ifTrue: [^ True  ]]
	ifFalse:[^ False ]
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 20:40'!
compareSystemMeasure: anUnit
	(anUnit class = self unit class ) ifFalse: [^ ErrorMeasure signal.  ].
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 21:26'!
convertTo: anUnit
	
	^Measure newWithAmount: ((anUnit factor / unit factor) * amount) andUnit: anUnit! !

!Measure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 02:09'!
convertToBase
	^self.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 20:26'!
hash

	"unit:=DistanceUnit new initializeWithaName: 'meter' andFactor: 1."
	"^ self class hash bitXor: (self convertTo: unit )amount hash ."
	^ self class hash bitXor: (self convertToBase)amount hash .! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
max:  anotherDistance
	self amount > (anotherDistance convertTo: unit) amount
	ifTrue: [ ^ self ]
	ifFalse:[^anotherDistance ]
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
min:  anotherDistance
	self amount < (anotherDistance convertTo: unit) amount
	ifTrue: [ ^ self ]
	ifFalse:[^anotherDistance ]
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 20:47'!
negated
	
	
	^(self class) newWithAmount: (self amount - (2*amount)) andUnit: self unit.
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
newWithAmount: anAmount andUnit: aDistanceUnit 
 	amount := anAmount.
	unit := aDistanceUnit.
	^self.
! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
printOn: aString
	aString  nextPutAll: amount asString, ' ', unit printString.
	amount >= 2 ifTrue: [ aString nextPut: $s]
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
to:  anotherDistance 
	^ self  to: (anotherDistance) by: (Distance newWithAmount: 1 andUnit: unit ).! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
to: toDistance by: stepDistance
	^DistanceInterval from:self to:toDistance by:stepDistance.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'GuadalupeFlores 5/20/2013 20:10'!
unit
	^unit.! !

Measure subclass: #ProductMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!ProductMeasure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/24/2013 23:32'!
+  aMeasure 			
	^  (self class) newWithAmount: (self amount + aMeasure amount) andUnit:  aMeasure unit.! !

!ProductMeasure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/24/2013 23:13'!
= aMeasure 
	^((self class)  = (aMeasure class) ) and: [(aMeasure) amount = (self ) amount]! !

Measure subclass: #SimpleMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

SimpleMeasure subclass: #DistanceMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceMeasure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 20:40'!
convertTo: anUnit

	self compareSystemMeasure: anUnit.
	^ DistanceMeasure newWithAmount: ((anUnit factor / unit factor) * amount) andUnit: anUnit! !

!DistanceMeasure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 03:00'!
convertToBase
	^ self convertTo: (DistanceUnit  new initializeWithaName: 'milimeter' andFactor: 1000) ! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 03:20'!
< aMeasure 	
	^ (self convertToBase) amount < (aMeasure convertToBase) amount.
	! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 02:27'!
= aMeasure

	^((self class)  = (aMeasure class) ) and: [(aMeasure convertToBase) amount = (self convertToBase) amount]! !

SimpleMeasure subclass: #TemperatureMeasure
	instanceVariableNames: 'toBaseBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TemperatureMeasure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 03:32'!
+  aMeasure 		
	self compareSystemMeasure: aMeasure unit.	
	^ ((self class)  newWithAmount: (amount + aMeasure amount) andUnit:  (aMeasure) unit).
	
! !

!TemperatureMeasure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 20:40'!
convertTo: anUnit
		self compareSystemMeasure: anUnit.
	^ self.! !

!TemperatureMeasure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 02:40'!
convertToBase

	unit name = 'fahrenheit' ifTrue: [^ Measure newWithAmount: ((amount -32) * 5/9) andUnit: (TemperatureUnit  new initializeWithaName: 'celsius' andFactor: 1 ) ].
	
	unit name = 'kelvin' ifTrue: [^ Measure newWithAmount: (amount - (27315/100) ) andUnit: (TemperatureUnit  new initializeWithaName: 'celsius' andFactor: 1 ) ].
	
	^ self.
	
      ! !

SimpleMeasure subclass: #TimeMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TimeMeasure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 20:40'!
convertTo: anUnit
		self compareSystemMeasure: anUnit.
	^ TimeMeasure newWithAmount: ((anUnit factor / unit factor) * amount) andUnit: anUnit! !

!TimeMeasure methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 20:09'!
convertToBase
	^ self convertTo: (TimeUnit  new initializeWithaName: 'second' andFactor: 1) ! !

Object subclass: #Unit
	instanceVariableNames: 'name factor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Unit commentStamp: '<historical>' prior: 0!
A DistanceUnit is una unidad de distancia.

Instance Variables
	factor:		<Object>
	name:		<Object>

factor
	- factor por el que hay que multiplicar para que llegue a un metro

name
	- nombre de la unidad
!

Unit subclass: #DistanceUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceUnit commentStamp: '<historical>' prior: 0!
A DistanceUnit is una unidad de distancia.

Instance Variables
	factor:		<Object>
	name:		<Object>

factor
	- factor por el que hay que multiplicar para que llegue a un metro

name
	- nombre de la unidad
!

!DistanceUnit class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/12/2013 23:58'!
newWithName: aName andFactor: aFactor 

	^self new initializeWithaName: aName andFactor: aFactor
	! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 03:12'!
type
	^DistanceMeasure! !

Unit subclass: #DivisionUnit
	instanceVariableNames: 'numeratorUnit denominatorUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DivisionUnit class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 23:24'!
numerator: aNumeratorUnit denominator: aDenominatorUnit
	^(DivisionUnit new) numerator: aNumeratorUnit denominator: aDenominatorUnit .
	! !

!DivisionUnit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 23:41'!
= aDivisionUnit

	^self class = aDivisionUnit class and: [(numeratorUnit  = aDivisionUnit numerator) and: (denominatorUnit  = aDivisionUnit denominator)].! !

!DivisionUnit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 23:41'!
denominator
	^denominatorUnit  ! !

!DivisionUnit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 23:40'!
numerator
	^numeratorUnit ! !

!DivisionUnit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 23:22'!
numerator: aNumeratorUnit denominator: aDenominatorUnit
	numeratorUnit :=aNumeratorUnit.
	denominatorUnit := aDenominatorUnit .
	! !

Unit subclass: #ProductUnit
	instanceVariableNames: 'unitOne unitTwo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!ProductUnit class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 21:17'!
unitOne: anUnitOne unitTwo: anUnitTwo	
	^ ProductUnit new unitOne: anUnitOne unitTwo: anUnitTwo	! !

!ProductUnit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 23:45'!
= aProductUnit

	^self class = aProductUnit class and: [(unitOne   = aProductUnit unitOne) and: (unitTwo  = aProductUnit unitTwo)].! !

!ProductUnit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 23:45'!
unitOne
	^unitOne ! !

!ProductUnit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 21:18'!
unitOne: anUnitOne unitTwo: anUnitTwo	
	unitOne:= anUnitOne.
	unitTwo:= anUnitTwo.! !

!ProductUnit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 23:46'!
unitTwo
	^unitTwo! !

Unit subclass: #TemperatureUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 03:12'!
type
	^TemperatureMeasure! !

Unit subclass: #TimeUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TimeUnit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 03:12'!
type
	^TimeMeasure! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/12/2013 23:58'!
newWithName: aName andFactor: aFactor 

	^self new initializeWithaName: aName andFactor: aFactor
	! !

!Unit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 21:37'!
* anUnit
	^ ProductUnit unitOne:self unitTwo:anUnit .! !

!Unit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/22/2013 23:24'!
/ anUnit
	^ DivisionUnit numerator:self denominator:anUnit .! !

!Unit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/13/2013 19:32'!
= aDistanceUnit

	^self class = aDistanceUnit class and: [(name = aDistanceUnit name) and: (factor = aDistanceUnit factor)].! !

!Unit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/12/2013 23:40'!
factor
	^factor.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/12/2013 23:47'!
initializeWithaName: aName andFactor: aFactor  
 	name := aName .
	factor := aFactor.
	^self.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/12/2013 23:39'!
name 
	^name.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/13/2013 12:13'!
printString
	^ name.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/25/2013 03:11'!
type
	^self subclassResponsibility .! !
